/*
 * Copyright (c) 2015 ezivkoc
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.page;

import wa.server.WAContext;
import wa.server.page.struct.WANavigation;
import wa.server.plugin.WAService;
import wa.server.plugin.WAServiceStatus;
import zutil.io.file.FileUtil;
import zutil.log.LogUtil;
import zutil.net.http.HttpHeaderParser;
import zutil.parser.DataNode;
import zutil.parser.Templator;
import zutil.plugin.PluginManager;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by Ziver on 2015-04-06.
 */
public class ServicePage implements WAPage {
    private static final Logger log = LogUtil.getLogger();
    public static final String NAVIGATION_NAME = "Services";
    private static final String TMPL_FILE = "WebContent/page/ServicePage.tmpl";

    private ArrayList<WAService> services;
    private ArrayList<ServiceStatusPage> statuses;

    public ServicePage(PluginManager pluginManager){
        this.services = pluginManager.toArray(WAService.class);
        this.statuses = new ArrayList<>();

        WANavigation nav = new WANavigation(NAVIGATION_NAME, this);
        for(WAService plugin : services) {
            nav.addSubNav(new WANavigation(plugin.getName()));
            statuses.add(new ServiceStatusPage(plugin.getStatus()));
        }
        WANavigation.addRootNav(nav);
    }


    @Override
    public Templator htmlResponse(WAContext context,
                                  HttpHeaderParser client_info,
                                  Map<String, Object> session,
                                  Map<String, String> cookie,
                                  Map<String, String> request) {

        try {
            int index = services.indexOf(context.getBreadcrumb().get(1).getResource());
            if(index < 0)
                return null;
            WAService obj = services.get(index);
            ServiceStatusPage statusPage = statuses.get(index);

            Templator tmpl = new Templator(FileUtil.find(TMPL_FILE));
            tmpl.set("service_status",
                    statusPage.htmlResponse(context, client_info, session, cookie, request).compile());
            return tmpl;

        }catch (IOException e){
            log.log(Level.SEVERE, null, e);
        }
        return null;
    }

    public DataNode jsonResponse(WAContext context,
                                 HttpHeaderParser client_info,
                                 Map<String, Object> session,
                                 Map<String, String> cookie,
                                 Map<String, String> request){

        return null;
    }


}
